# coding: utf-8

import os
import gettext

from tionix_vdi_client.helpers import Localization
from tionix_vdi_client.settings import CONF, BASE_DIR

#  The translation files will be under
#  @LOCALE_DIR@/@LANGUAGE@/LC_MESSAGES/@APP_NAME@.mo
APP_NAME = "vdiclient"

# APP_DIR = os.path.join (sys.prefix, 'share')
# .mo files will then be located in APP_Dir/i18n/LANGUAGECODE/LC_MESSAGES/
LOCALE_DIR = os.path.join(BASE_DIR, 'i18n')

locale = Localization.locales_dict.get(CONF.language)
languages = [locale]
if Localization.EN_US_CODE not in languages:
    languages.append(Localization.EN_US_CODE)

mo_location = LOCALE_DIR

gettext.install(True, localedir=None)
gettext.find(APP_NAME, mo_location)
gettext.textdomain(APP_NAME)
gettext.bind_textdomain_codeset(APP_NAME, "UTF-8")
language = gettext.translation(APP_NAME, mo_location, languages=languages,
                               fallback=True)
ugettext = language.ugettext
ungettext = language.ungettext


def switch_language(lang):
    """
    Change gettext language.

    Note: gettext that was already imported in module scope
     with "from i18n import _" statement will not be affected.
    """
    global ugettext, ungettext
    t = gettext.translation(APP_NAME, mo_location,
                            languages=[lang], fallback=True)
    ugettext = t.ugettext
    ungettext = t.ungettext
