import logging
from collections import deque

_log_buffer = []


class BufferingStreamHandler(logging.StreamHandler):

    def __init__(self, stream=None, buffer_size=10):
        super(BufferingStreamHandler, self).__init__(stream)
        global _log_buffer
        _log_buffer = deque(maxlen=buffer_size)
        self.buffer = _log_buffer

    def emit(self, record):
        self.buffer.append(self.format(record))
        super(BufferingStreamHandler, self).emit(record)


def get_log_msg():
    """Return last saved log messages."""
    global _log_buffer
    return "\n".join(reversed(_log_buffer))
