#!/usr/bin/env python
import argparse
import os
import sys

from tionix_vdi_client.client import connect_without_ui, create_parser


err_code = os.EX_SOFTWARE

PASS = '87654321'
PROJECT = 'script'


def check_vms(output_file=None, source_file=None):
    if source_file:
        try:
            with open(source_file, 'r') as fh:
                content = fh.readlines() or []
        except EnvironmentError as err:
            print 'Failed to read source file {0}. {1}'.format(
                source_file, err)
            return err_code
        else:
            content = [x.strip() for x in content]

        if content and output_file:
            result_pattern = '{0} {1}\n'
            results = []
            for item in content:
                args = create_parser().parse_args([
                    '--username', item, '--password',
                    PASS, '--project', PROJECT])
                result = connect_without_ui(args)
                result = 'FAIL' if result else 'OK'
                results.append(result_pattern.format(item, result))

            if results:
                try:
                    with open(output_file, 'w') as fh:
                        fh.writelines(results)
                except EnvironmentError as err:
                    print 'Failed to write output to file {0}. {1}'.format(
                        output_file, err)
                    print 'The result is: {0}'.format(results)
                    return err_code


def main():
    parser = argparse.ArgumentParser()
    parser.description = "Check VDIclient connections."
    parser.add_argument(
        '-s', '--source',
        dest='source',
        help='File name with users'
    )
    parser.add_argument(
        '-o', '--output',
        dest='file',
        help='File name for output'
    )
    args = parser.parse_args()
    return check_vms(output_file=args.file, source_file=args.source)


if __name__ == '__main__':
    sys.exit(main())
