# coding: utf-8

import unittest

from tionix_vdi_client import vdi_connect
from tionix_vdi_client.i18n import ugettext as _


class VDIConnectionTest(unittest.TestCase):

    def test_check_vdi_server_connection(self):
        """Checks that VDIclient can connect to VDIserver.

        :lang:ru Проверяет что VDIclient может подключиться к VDIserver.
        """
        def get_response_code(response):
            return response.status_code

        params = {
            'user': 'self-diagnostic-user',
            'password': 'non-existing-password',
            'domain_name': 'non-existing-domain',
        }
        try:
            vdi_client = vdi_connect.VdiClient(**params)
            vdi_client._parse_response = get_response_code
        except Exception as err:
            self.fail(unicode(err))
        try:
            resp_code = vdi_client._action('request-vm')
        except Exception as err:
            self.fail(_(u"Failed to connect to VDIserver: "
                        u"{reason}.").format(reason=unicode(err)))
        self.assertEqual(resp_code, 400,
                         _(u"Unexpected server response code. "
                           u"Got {0} instead of 400.").format(resp_code))
